# Zprovoznění generátoru

## Potřebné nástroje

Ke spuštění generátoru je zapotřebí mít Node.js 13.0.0+ a npm 6.0.0 + (ten by už měl být zakomponován v Node.js). Po
instalaci Node.js je nutné nainstalovat Yeoman pomocí příkazu ```npm install -g yo```.

## Instalace generátoru

Instalace se provede příkazem ```npm link``` ve složce s generátorem.

## Spuštění generátoru

Generátor možné spustit buď výběrem z nainstalovaných generátoru v rozhraní Yeomena, spuštěno příkazem ```yo```, nebo
spuštění generátoru rovnou příkazem ```yo cca-rocket-backend```.

### Vstupy z příkazové řádky

Generátor backendu má dva nepovinné parametry v příkazové řádce. Jsou to --projectPath "cesta ke složce projektu"
a --mappingFile "cesta k souboru konfigurace". Project path je složka, kam se má cílový kód vygenerovat. V případě, že
není zadán, jsou soubory vygenerovány do aktuální složky. Mapping file je JSON soubor , který obsahuje konfiguraci typu
proměnných. Má pole jménem types. V tomto poli jsou nadefinované všechny typy proměnných. Každý typ se skládá se 4
povinných a 3 nepovinných parametrů.

- Povinné
  - ea – jméno typu v prostredí Enterprise Architect
  - java – jméno type v Jave
  - openApi – jméno typu v OpenAPI
  - db – jméno typu v Liquibase scriptu
- Nepovinné
  - length – maximální délka, používá při různě dlouhých definic Stringu
  - javaImport – jaký import je v jave potreba na zkompilovatelný kód, príklad java.time.LocalDate
  - openApiFormat – formát v OpenAPI, například UUID má typ string a formát uuid

### Vstupy po spuštění generátoru

Po spuštení generátoru se yeoman zeptá na 4 parametry.

1. cesta k souboru s definicí entity
2. název kořenového balíčku, jednotlivé balíčky jsou odděleny tečkou
3. název schématu, kterému entita v databázi patří, vše je zapsáno malými písmeny, jednotlivá slova jsou oddělena znakem
   podtržítka _
4. kontextový kořen URL dané komponenty   

#### Formát souboru s definicí entity

Formát definice entity se skládá z entityName obsahující název entity a pole atributes. Každý atribut se má 3 povinné
parametry.

- name – název atributu
- type – typ atributu v Enterprise Architectu
- nullable – true/false, jestli muže atribut být null

## Výstupem generátoru

Výstopem je kód služby obsahující CRUD operacem, entitu, DTO, Mapper, Repository. 

### Kroky po vygenerování
Pro správnou funkčnost je potřeba přesunout obsah ze souboru ```pom.txt``` do souboru ```pom.xml``` do ```plugins```, 
```plugin```, ```openapi-generator-maven-plugin```, ```executions```. Pokud chcete vytvořit 
entity v databázi, je potřeba obsah souboru ```changelog.txt``` vložit do nějakého vhodného ```changesetu``` a ten spustit. 
Také je potřeba přidat práva určené role k přístupu na tabulku. Jako poslední je potřeba 
implementovat testy.
