const stringUtil = require('./string-util')

module.exports = {

    /**
     * edites names from space format to camel case format
     * @param atributes of entity
     */
    editNamesToCamelCase: function (atributes) {
        for (let atribute of atributes) {
            atribute.name = stringUtil.nameLower(stringUtil.camelCase(atribute.name));
        }
    },

    /**
     * adds db name version to all atributes
     * @param atributes of entity, that are beeing extended
     */
    createDbNames: function (atributes) {
        for (let i = 0; i < atributes.length; i++) {
            atributes[i].dbName = stringUtil.underscoreName(atributes[i].name);
        }
    },

    /**
     * changes from EA types to java types
     * @param atributes of entity, that are beeing edited
     * @param mapping object with definition of types in all languages
     */
    editTypesJava: function (atributes, mapping) {
        for (let atribute of atributes) {
            for (let type of mapping.types) {
                if (type.ea === atribute.type) {
                    atribute.original = atribute.type;
                    atribute.type = type.java;
                    if (type.length != null) {
                        atribute.length = type.length;
                    }
                    break;
                }
            }
        }
    },

    /**
     * changes form java types to yaml types
     * @param atributes of entity, that are beeing edited
     * @param mapping object with definition of types in all languages
     */
    editTypesYaml: function (atributes, mapping) {
        for (let atribute of atributes) {
            for (let type of mapping.types) {
                if (type.ea === atribute.original) {
                    atribute.type = type.openApi;
                    atribute.format = type.openApiFormat;
                    break;
                }
            }
        }
    },

    editTypesDb: function (atributes, mapping) {
        for (let atribute of atributes) {
            for (let type of mapping.types) {
                if (type.ea === atribute.original) {
                    atribute.type = type.db;
                    break;
                }
            }
        }
    },
}
