package <%= rootPackageName %>.db.domain.<%= schemeName %>;


import cz.cca.hedgehog.core.db.audit.VersionAwareEntity;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;
import java.util.UUID;
<% for (type of types) {
    if (type.javaImport == null){
        continue;
    }
    for (atribute of atributes) {
        if (atribute.type === type.java) {
            %>import <%= type.javaImport %>;
<%          break;
        }
    }
} %>
@Entity
@Data
@NoArgsConstructor
@Table(name = "<%= entityDbName %>", schema = "<%= schemeDbName %>")
public class <%= entityName %>Ent extends VersionAwareEntity<UUID> {

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    @Column(name = "guid", nullable = false)
    private UUID guid;
    <% for (atribute of atributes) { %>
    @Column(name = "<%= atribute.dbName %>"<% if (atribute.nullable === false) {
        %>, nullable = false<%
    } %><% if (atribute.length != null) {
        %>, length = <%= atribute.length %><%
    } %>)
    private <%= atribute.type %> <%= atribute.name %>;
    <% } %>
    @Override
    public UUID getId() {
        return guid;
    }
}
