package  <%= rootPackageName %>.modules.<%= entityNameAllLower %>;

import cz.cca.hedgehog.common.error.exceptions.RecordNotFoundException;
import cz.cca.hedgehog.core.validations.RequestValidator;
import <%= rootPackageName %>.db.domain.<%= schemeName %>.<%= entityName %>Ent;
import <%= rootPackageName %>.db.repo.<%= schemeName %>.<%= entityName %>Repository;
import <%= rootPackageName %>.modules.<%= entityNameAllLower %>.api.<%= entityName %>Mapper;
import <%= rootPackageName %>.modules.<%= entityNameAllLower %>.api.<%= entityName %>ApiDelegate;
import <%= rootPackageName %>.modules.<%= entityNameAllLower %>.api.dto.<%= entityName %>DetailDto;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;
import java.util.Optional;
import java.util.UUID;
import java.util.stream.Collectors;

@Service
@Transactional
public class <%= entityName %>ServiceImpl implements <%= entityName %>ApiDelegate {

    @Autowired
    private <%= entityName %>Repository <%= entityNameLower %>Repository;

    @Autowired
    private <%= entityName %>Mapper <%= entityNameLower %>Mapper;

    @Override
    public ResponseEntity<<%= entityName %>DetailDto> get<%= entityName %>(UUID guid<%= entityName %>) {
        <%= entityName %>Ent <%= entityNameLower %> = <%= entityNameLower %>Repository.findById(guid<%= entityName %>)
                .orElseThrow(() -> new RecordNotFoundException(guid<%= entityName %>, <%= entityName %>Ent.class));

        return new ResponseEntity<>(<%= entityNameLower %>Mapper.map(<%= entityNameLower %>), HttpStatus.OK);
    }

    @Override
    public ResponseEntity<Void> put<%= entityName %>(UUID guid<%= entityName %>, <%= entityName %>DetailDto <%= entityNameLower %>DetailDto) {
        RequestValidator.putSameGuid(guid<%= entityName %>, <%= entityNameLower %>DetailDto.getGuid());

        <%= entityName %>Ent <%= entityNameLower %> = <%= entityNameLower %>Repository.findById(guid<%= entityName %>, <%= entityNameLower %>DetailDto.getVersion())
                .orElseThrow(() -> new RecordNotFoundException(guid<%= entityName %>, <%= entityName %>Ent.class));

        <%= entityNameLower %>Mapper.map(<%= entityNameLower %>, <%= entityNameLower %>DetailDto);

        return new ResponseEntity<>(HttpStatus.OK);
    }

    @Override
    public ResponseEntity<UUID> post<%= entityName %>(<%= entityName %>DetailDto <%= entityNameLower %>DetailDto) {
        <%= entityName %>Ent <%= entityNameLower %> = new <%= entityName %>Ent();

        <%= entityNameLower %>Mapper.map(<%= entityNameLower %>, <%= entityNameLower %>DetailDto);
        <%= entityNameLower %> = <%= entityNameLower %>Repository.save(<%= entityNameLower %>);

        return new ResponseEntity<>(<%= entityNameLower %>.getGuid(), HttpStatus.CREATED);
    }
}
