package <%= rootPackageName %>;

import io.restassured.RestAssured;
import io.restassured.http.ContentType;
import org.hamcrest.CoreMatchers;
import org.junit.Test;
import org.junit.jupiter.api.Assertions;
import org.junit.runner.RunWith;
import org.springframework.test.context.junit4.SpringRunner;

//todo pridat anotaci testu komponenty
@RunWith(SpringRunner.class)
public class <%= entityName %>Test {

    private static final String COMMON_ENDPOINT = "<%= contextRoot %>api/<%= entityNameDash %>/";

    @Test
    public void implementUs() {
        Assertions.assertTrue(false);
    }

    //get testy
    @Test
    public void get<%= entityName %>Ok() {
        RestAssured.get(COMMON_ENDPOINT)
                .then()
                .statusCode(200);
    }

    @Test
    public void get<%= entityName %>NotFound() {
        RestAssured.get(COMMON_ENDPOINT + UUID.randomUUID().toString())
                .then()
                .statusCode(404);
    }

    //put testy
    @Test
    public void put<%= entityName %>Ok() {
        String putJson = "{}";
        RestAssured.given()
                .contentType(ContentType.JSON)
                .body(putJson)
                .put(COMMON_ENDPOINT)
                .then()
                .statusCode(200);

        RestAssured.get(COMMON_ENDPOINT)
                .then()
                .statusCode(200)
                .body("guid", CoreMatchers.equalTo(""));
    }

    @Test
    public void put<%= entityName %>NotFound() {
        String putJson = "{}";
        RestAssured.given()
                .contentType(ContentType.JSON)
                .body(putJson)
                .put(COMMON_ENDPOINT)
                .then()
                .statusCode(404);
    }

    @Test
    public void put<%= entityName %>VersionConflict() {
        String putJson = "{}";
        RestAssured.given()
                .contentType(ContentType.JSON)
                .body(putJson)
                .put(COMMON_ENDPOINT)
                .then()
                .statusCode(409);
    }

    @Test
    public void put<%= entityName %>GuidConflict() {
        String putJson = "{}";
        RestAssured.given()
                .contentType(ContentType.JSON)
                .body(putJson)
                .put(COMMON_ENDPOINT)
                .then()
                .statusCode(409);
    }

    //post testy
    @Test
    public void post<%= entityName %>Ok() {
        String postJson = "{}";
        RestAssured.given()
                .contentType(ContentType.JSON)
                .body(postJson)
                .post(COMMON_ENDPOINT)
                .then()
                .statusCode(200);
    }

}

