package <%= rootPackageName %>.config.persistence;

import cz.cca.config.api.params.RefreshPeriod;
import cz.cca.config.api.spring.CcaConfiguration;
import cz.cca.config.api.spring.CcaConfigurationProxy;
import cz.cca.hedgehog.core.db.domain.konfigurace.ParametrEnt;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import javax.persistence.EntityManagerFactory;

/**
 * Konfigurační třída se stará o inicializaci přístupu k databázovým parametrům.
 */
@Configuration
public class ParameterConfig {

    @Bean(name = "<%= componentNameLower %>Configuration", destroyMethod = "closeEntityManager")
    public CcaConfiguration ccaConfiguration(@Qualifier("<%= componentNameLower %>EntityManagerFactory") EntityManagerFactory emf) {
        return new CcaConfigurationProxy(emf, ParametrEnt.class, RefreshPeriod.inMinutes(10), true);
    }

}
