package <%= rootPackageName %>.config.security;

import cz.cca.hedgehog.user.config.security.KeycloakSecurityConfig;
import org.springframework.context.annotation.Configuration;
import org.springframework.security.config.annotation.web.builders.HttpSecurity;
import org.springframework.security.config.annotation.web.builders.WebSecurity;
import org.springframework.security.config.annotation.web.configuration.EnableWebSecurity;

@Configuration
@EnableWebSecurity
public class SecurityConfig extends KeycloakSecurityConfig {

    @Override
    public void configure(final WebSecurity web) throws Exception {
        super.configure(web);
        web.ignoring()
                .antMatchers("/api/keycloak/**")
                .antMatchers("/swagger-ui.html")
                .antMatchers("/webjars/**")
                .antMatchers("/swagger-resources/**")
                .antMatchers("/swagger/docs/**")
                .antMatchers("/services/**");
    }

    @Override
    protected void configure(final HttpSecurity http) throws Exception {
        super.configure(http);
        setPristupy(http);
    }

    private void setPristupy(final HttpSecurity http) throws Exception {
        http.anonymous().disable().csrf().disable().authorizeRequests()
                .antMatchers("/api").authenticated().anyRequest().permitAll();
    }

}
