package <%= rootPackageName %>.config.web;

import cz.cca.hedgehog.core.filters.ApiCallLoggingFilter;
import org.springframework.context.annotation.Configuration;
import org.springframework.web.servlet.config.annotation.CorsRegistry;
import org.springframework.web.servlet.config.annotation.InterceptorRegistry;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurer;

/**
 * V teto tride budou zaregistrovany servlety, filtry, listenery atd.
 */
@Configuration
public class WebConfig implements WebMvcConfigurer {

    /**
     * Zaregistrovani filtru
     *
     * @param registry
     */
    @Override
    public void addInterceptors(InterceptorRegistry registry) {
        registry.addInterceptor(new ApiCallLoggingFilter());
    }

    /**
     * Nastaveni CORS
     *
     * @param registry
     */
    @Override
    public void addCorsMappings(CorsRegistry registry) {
        registry.addMapping("/**")
                .allowedOrigins("*")
                .allowedHeaders("origin", "content-type", "accept")
                .allowedMethods("GET", "POST", "PUT", "DELETE", "OPTIONS", "HEAD", "PATCH")
                .allowCredentials(true)
                .maxAge(1200000L);
    }

}
