package <%= rootPackageName %>.annotation;

import <%= rootPackageName %>.<%= componentNameCamel %>Application;
import <%= rootPackageName %>.config.TestDataSourceConfig;
import cz.cca.hedgehog.test.annotation.RestTest;
import cz.cca.hedgehog.test.config.MethodSecurityConfig;
import cz.cca.hedgehog.test.config.SecurityConfig;
import cz.cca.hedgehog.test.listener.LiquibaseTestListener;
import cz.cca.hedgehog.test.listener.RestAssuredInitListener;
import cz.cca.hedgehog.test.util.HeadgehogUserListener;
import cz.cca.hedgehog.test.util.TestUserConfiguration;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.ActiveProfiles;
import org.springframework.test.context.TestExecutionListeners;
import org.springframework.test.context.transaction.TransactionalTestExecutionListener;

import java.lang.annotation.Documented;
import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * Anotace, která formu meta-anotací zahrnuje všechny typické anotace pro testy REST controller-ů.
 * <p>
 * Jednou z těchto meta-anotací je i anotace {@link cz.cca.hedgehog.test.annotation.Test &#64;RocketTest}, takže i její
 * meta-anotace jsou zahrnuty v této anotaci.
 */
@Target(ElementType.TYPE)
@Retention(RetentionPolicy.RUNTIME)
@Documented
@SpringBootTest(classes = {
        <%= componentNameCamel %>Application.class,
        TestUserConfiguration.class,
        TestDataSourceConfig.class,
        SecurityConfig.class,
        MethodSecurityConfig.class,
},
        webEnvironment = SpringBootTest.WebEnvironment.RANDOM_PORT)
@ActiveProfiles({"test"})
@TestExecutionListeners({
        RestAssuredInitListener.class,
        TransactionalTestExecutionListener.class,
        LiquibaseTestListener.class,
        HeadgehogUserListener.class
})
@RestTest
public @interface <%= componentNameCamel %>Test {
}
