module.exports = {

    /**
     * deletes spaces from string a makes first letter of each word uppercase
     * @param name string that is edited
     * @returns {string}
     */
    camelCase: function (name) {
        let words = name.split('-');
        for (let i = 0; i < words.length; i++) {
            words[i] = words[i].charAt(0).toLocaleUpperCase() + words[i].slice(1);
        }
        return words.join('');
    },

    /**
     * deletes spaces from string a makes first letter of each word uppercase
     * @param name string that is edited
     * @returns {string}
     */
    spaceFirstLettersUpperCase: function (name) {
        let words = name.split('-');
        for (let i = 0; i < words.length; i++) {
            words[i] = words[i].charAt(0).toLocaleUpperCase() + words[i].slice(1);
        }
        return words.join(' ');
    },

    /**
     * seperates words from dases to dots
     * @param name words seperated with dashes
     * @returns {string}
     */
    dotSeperator: function (name) {
        return name.split('-').join('.');
    },

    /**
     * eperates words from dases to spaces
     * @param name
     * @returns {string}
     */
    spaceSeperator: function (name) {
        return name.split('-').join(' ');
    },

    /**
     * cuts last part of package name
     * @param packageName package name
     * @returns {string}
     */
    cutLastPackage: function (packageName) {
        let words = packageName.split('.');
        let finalName = '';
        for (let i = 0; i < words.length - 1; i++) {
            finalName += words[i] + '.';
        }
        return finalName.slice(0, -1);
    },

    /**
     * makes first letter of string lower case
     * @param name
     * @returns {string}
     */
    nameLower: function (name) {
        return name.charAt(0).toLocaleLowerCase() + name.slice(1);
    },

    /**
     * creates path from package name
     * @param packageName string
     * @returns {string}
     */
    packagePath: function (packageName) {
        return packageName.split('.').join('/');
    },

    /**
     * adds / to end of path if it exists
     * if not return empty string
     * @param path - path we are editing
     * @returns {string|*}
     */
    path: function (path) {
        if (path != null && path.length > 0) {
            if (path.charAt(path.length - 1) !== '/') {
                return path.concat('/');
            }
        }
        return "";
    }
}
