package cz.cca.hedgehog.ciselnik.modules.ciselniky.service;

import cz.cca.hedgehog.ciselnik.db.domain.ciselniky.<%= nazev %>Ent;
import cz.cca.hedgehog.ciselnik.db.repo.ciselniky.<%= nazev %>Repository;
import cz.cca.hedgehog.ciselnik.modules.ciselniky.api.<%= nazev %>ApiDelegate;
import cz.cca.hedgehog.ciselnik.modules.ciselniky.api.dto.<%= nazev %>Dto;
import cz.cca.hedgehog.ciselnik.modules.ciselniky.api.dto.<%= nazev %>Mapper;
import cz.cca.hedgehog.common.error.exceptions.RecordAlreadyExistsException;
import cz.cca.hedgehog.common.error.exceptions.RecordNotFoundException;
import cz.cca.hedgehog.core.api.tags.ApiTagsV1;
import cz.cca.hedgehog.core.validations.RequestValidator;
import io.swagger.annotations.Api;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.Objects;
import java.util.UUID;

@Service
@Transactional
@Api(tags = ApiTagsV1.CISELNIKY)
public class <%= nazev %>Impl implements <%= nazev %>ApiDelegate {

  @Autowired
  private <%= nazev %>Mapper <%= nazevLower%>Mapper;

  @Autowired
  private <%= nazev %>Repository <%= nazevLower%>Repository;

  @Override
  public ResponseEntity<Void> post<%= nazev %>(<%= nazev %>Dto <%= nazevLower %>Dto) {
    <%= nazev %>Dto.setKod(<%= nazev %>Dto.getKod().toUpperCase());
    if (Objects.nonNull(<%= nazev %>Repository.findByKod(<%= nazevLower%>Dto.getKod()))) {
      throw new RecordAlreadyExistsException(CiselnikCommon.postConflictErrorText(<%= nazevLower%>Dto.getKod()));
    }

    <%= nazev %>Ent <%= nazevLower%> = new <%= nazev %>Ent();
    <%= nazevLower%>Mapper.map(<%= nazevLower%>, <%= nazevLower%>Dto);
    <%= nazevLower%>.setKod(<%= nazevLower%>Dto.getKod());

    <%= nazevLower%>Repository.save(<%= nazevLower%>);

    return new ResponseEntity<>(HttpStatus.CREATED);
  }

  @Override
  public ResponseEntity<Void> put<%= nazev %>(UUID guid, <%= nazev %>Dto <%= nazevLower%>Dto) {
    RequestValidator.putRequestCheck(guid, <%= nazevLower%>Dto.getGuid(), <%= nazevLower%>Dto.getVersion());
    RequestValidator.validPlatnost(<%= nazevLower%>Dto.getPlatnostOd(), <%= nazevLower%>Dto.getPlatnostDo());

    <%= nazev %>Ent <%= nazevLower%> = <%= nazevLower%>Repository.findById(guid, <%= nazevLower%>Dto.getVersion())
      .orElseThrow(() -> new RecordNotFoundException(guid, <%= nazev %>Ent.class));
    <%= nazevLower%>Mapper.map(<%= nazevLower%>, <%= nazevLower%>Dto);

    return new ResponseEntity<>(HttpStatus.OK);
  }
}
