package cz.bc.ciselnik.commands;

import org.jboss.forge.addon.resource.Resource;
import org.jboss.forge.addon.resource.ResourceFactory;
import org.jboss.forge.addon.templates.Template;
import org.jboss.forge.addon.templates.TemplateFactory;
import org.jboss.forge.addon.templates.freemarker.FreemarkerTemplate;
import org.jboss.forge.addon.ui.command.AbstractUICommand;
import org.jboss.forge.addon.ui.context.UIBuilder;
import org.jboss.forge.addon.ui.context.UIContext;
import org.jboss.forge.addon.ui.context.UIExecutionContext;
import org.jboss.forge.addon.ui.facets.HintsFacet;
import org.jboss.forge.addon.ui.hints.InputType;
import org.jboss.forge.addon.ui.input.UIInput;
import org.jboss.forge.addon.ui.metadata.UICommandMetadata;
import org.jboss.forge.addon.ui.metadata.WithAttributes;
import org.jboss.forge.addon.ui.util.Metadata;
import org.jboss.forge.addon.ui.util.Categories;
import org.jboss.forge.addon.ui.result.Result;
import org.jboss.forge.addon.ui.result.Results;

import javax.inject.Inject;
import java.io.File;
import java.io.FileOutputStream;
import java.nio.charset.StandardCharsets;
import java.util.HashMap;
import java.util.Map;
import java.util.Objects;

public class Ciselnik extends AbstractUICommand {

	@Inject
	@WithAttributes(label = "CiselnikName", required = true, description = "Enter ciselnik name")
	private UIInput<String> input;

	@Override
	public UICommandMetadata getMetadata(UIContext context) {
		return Metadata.forCommand(Ciselnik.class)
				.name("ciselnik")
				.category(Categories.create("ciselnik"));
	}

	@Override
	public void initializeUI(UIBuilder builder) throws Exception {
		input.getFacet(HintsFacet.class).setInputType(InputType.TEXTBOX);
		builder.add(input);
	}

	@Inject
	private ResourceFactory resourceFactory;

	@Inject
	private TemplateFactory templateFactory;

	@Override
	public Result execute(UIExecutionContext context) throws Exception {
		String jmeno = Objects.nonNull(input.getValue()) ? input.getValue() : "Mena";
		File templeteFile = new File("D:\\Programs\\Dropbox\\School\\bc\\ciselnikGen\\src\\main\\resources\\ciselnik.java");
		Resource<File> resource = resourceFactory.create(templeteFile);
		Template template = templateFactory.create(resource, FreemarkerTemplate.class);

		Map<String,Object> params = new HashMap<String,Object>();
		params.put("name", jmeno);
		params.put("nameLower", jmeno.toLowerCase());

		String text = template.process(params);

		FileOutputStream stream = new FileOutputStream(new File(jmeno + "ServiceImpl.java"));
		stream.write(text.getBytes(StandardCharsets.UTF_8));
		stream.close();

		return Results.success("Command 'generate' successfully executed!");
	}
}
