package cz.cca.hedgehog.ciselnik.modules.ciselniky.service;

import cz.cca.hedgehog.ciselnik.db.domain.ciselniky.${name}Ent;
import cz.cca.hedgehog.ciselnik.db.repo.ciselniky.${name}Repository;
import cz.cca.hedgehog.ciselnik.modules.ciselniky.api.${name}ApiDelegate;
import cz.cca.hedgehog.ciselnik.modules.ciselniky.api.dto.${name}Dto;
import cz.cca.hedgehog.ciselnik.modules.ciselniky.api.dto.${name}Mapper;
import cz.cca.hedgehog.common.error.exceptions.RecordAlreadyExistsException;
import cz.cca.hedgehog.common.error.exceptions.RecordNotFoundException;
import cz.cca.hedgehog.core.api.tags.ApiTagsV1;
import cz.cca.hedgehog.core.validations.RequestValidator;
import io.swagger.annotations.Api;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.Objects;
import java.util.UUID;

@Service
@Transactional
@Api(tags = ApiTagsV1.CISELNIKY)
public class ${name}Impl implements ${name}ApiDelegate {

  @Autowired
  private ${name}Mapper ${nameLower}Mapper;

  @Autowired
  private ${name}Repository ${nameLower}Repository;

  @Override
  public ResponseEntity<Void> post${name}(${name}Dto ${nameLower}Dto) {
    ${name}Dto.setKod(${name}Dto.getKod().toUpperCase());
    if (Objects.nonNull(${name}Repository.findByKod(${nameLower}Dto.getKod()))) {
      throw new RecordAlreadyExistsException(CiselnikCommon.postConflictErrorText(${nameLower}Dto.getKod()));
    }

    ${name}Ent ${nameLower} = new ${name}Ent();
    ${nameLower}Mapper.map(${nameLower}, ${nameLower}Dto);
    ${nameLower}.setKod(${nameLower}Dto.getKod());

    ${nameLower}Repository.save(${nameLower});

    return new ResponseEntity<>(HttpStatus.CREATED);
  }

  @Override
  public ResponseEntity<Void> put${name}(UUID guid, ${name}Dto ${nameLower}Dto) {
    RequestValidator.putRequestCheck(guid, ${nameLower}Dto.getGuid(), ${nameLower}Dto.getVersion());
    RequestValidator.validPlatnost(${nameLower}Dto.getPlatnostOd(), ${nameLower}Dto.getPlatnostDo());

    ${name}Ent ${nameLower} = ${nameLower}Repository.findById(guid, ${nameLower}Dto.getVersion())
      .orElseThrow(() -> new RecordNotFoundException(guid, ${name}Ent.class));
    ${nameLower}Mapper.map(${nameLower}, ${nameLower}Dto);

    return new ResponseEntity<>(HttpStatus.OK);
  }
}
